Index: MLXMANIFEST
===================================================================
--- MLXMANIFEST	(revision 504)
+++ MLXMANIFEST	(revision 510)
@@ -7,5 +7,5 @@
 library/fnmatch.pyc	3414	4d50000f78e903598af06ef1c5cfb3ef
 library/libexpat-1.dll	143096	701659d3689bf4a8265b669b7d774255
-library/gtk/_gtk.pyc	549	0d0a77cca8e542a13b7f8ed84ae3a547
+library/gtk/_gtk.pyc	549	375cff8defe663bc7e8a404bafdbf319
 library/encodings/cp858.pyc	7591	02054a0b8e91b9758826eb70cddf096f
 library/mlx/pirep.pyc	4623	2a008f269c900fb604b94b4e427f61b5
@@ -13,5 +13,5 @@
 library/encodings/unicode_internal.pyc	2022	1e902113491e0c334b44deb0c8940e01
 library/libpango-1.0-0.dll	333729	5a14efd93ee27cfe960220fe4a904911
-library/mlx/gui/gui.pyc	51077	c54af5d2051a31bc3c46a7d690cd1552
+library/mlx/gui/gui.pyc	50869	73790abccc30d5cbea66bd3801346221
 library/stat.pyc	2503	d3b6dc7a54e705219f04d0be75a212de
 library/posixpath.pyc	10734	d694316c239784c444b252c801c97efa
@@ -22,6 +22,6 @@
 doc/manual/hu/bugreport.png	12385	c71c7db56f19870ae5d6bb7f533d3679
 library/share/locale/hu/LC_MESSAGES/gtk20.mo	58794	6ee4491ae7bc9d3dfb778578eb29a0b3
-library/gobject/_gobject.pyc	573	92d29c5d8b466d18acef25eaa9cba97f
-locale/en/LC_MESSAGES/mlx.mo	61639	aa73425f6f3c43fa83be90b9909f369e
+library/gobject/_gobject.pyc	573	15a834f99f84e8c25ded4c9b4f444d56
+locale/en/LC_MESSAGES/mlx.mo	61484	921f96175cd9e4afd7c6b2317bc90cc0
 library/encodings/utf_7.pyc	1747	2beeb059236527197d6c640396476ce8
 doc/manual/hu/pirepViewer.png	26835	267e4325e550ed14ed22f86a2c7e8e9d
@@ -63,5 +63,5 @@
 library/encodings/utf_8.pyc	1806	4b8dee0284ea2f55c4142fcde7463524
 library/unicodedata.pyd	688128	c856c31a03dc892e4f2aee93d0bfee44
-locale/hu/LC_MESSAGES/mlx.mo	66240	db0a23e9f1d4657562180946ae340f22
+locale/hu/LC_MESSAGES/mlx.mo	66076	971aaf421fda1cb5174dbf68b87aa8a7
 library/encodings/mac_roman.pyc	2716	4b4745eccfcb77860b70b374ac07fbcc
 library/copy_reg.pyc	4893	7a58bc441232056d1c123cd3375b3774
@@ -76,5 +76,5 @@
 library/_hashlib.pyd	287232	a1a18de0644f481749fcbcf26005eeaf
 doc/manual/en/monitorWindow.png	20886	42e08d10c758e21209c4c021f391dee7
-library/_hashlib.pyc	549	ec9a5e38a98eaf491bd44048fe3f8d16
+library/_hashlib.pyc	549	3e6c18da5d87853e1652c77d4f40cf4e
 library/libpng14-14.dll	230529	f3a15497e25baaa721f96638d7a4d2f8
 library/copy.pyc	11674	30d1745c5e38ab170f8a0486fbebf305
@@ -90,5 +90,5 @@
 library/traceback.pyc	11223	50ace5c2c6c040a923082442da94cd78
 library/_weakrefset.pyc	9290	a56e87c491c0511cd329a3c8c4cd9563
-library/mlx/flight.pyc	17473	8b37fd80c11c3a89738f5e4e1cda5578
+library/mlx/flight.pyc	17303	96ca499dc0257e7051e5895ca5a7a265
 library/urllib2.pyc	43566	7eb57ea0dcd1086d1d9073a5cefb0903
 doc/manual/en/flightSelection.png	29847	7817c8f5ed8d7fe64cf72d0addaf3e4a
@@ -117,5 +117,5 @@
 library/encodings/mac_latin2.pyc	4717	564dbaf5c296a147203eb821dc2466ba
 library/encodings/utf_16_be.pyc	1854	84a1d1465453727af051eaeeb853782f
-library/mlx/fsuipc.pyc	72456	eafa9e3e0e9bdff01306dfb2863de12b
+library/mlx/fsuipc.pyc	72548	b2c4676aa9976a2f425ab624682e39aa
 library/xml/sax/__init__.pyc	3579	c78222ad1fd4f3dbdea06666fe74e84e
 doc/manual/en/connect.png	27436	5406dfe5408569cb95499c057bf0185b
@@ -135,6 +135,6 @@
 sounds/767taxi.mp3	160496	4cb43cda6e1214fbe15328a716827345
 doc/manual/en/prefsAdvanced.png	16169	64c14e0842c413cac98b92926279f3e0
-library/cairo/_cairo.pyc	561	6ac388cead1acc49e51e05d06033ad23
-library/win32file.pyc	552	e12cc4667c80e4f5fb88cf46ec92d734
+library/cairo/_cairo.pyc	561	70beff493bb08d983e44f832660acb73
+library/win32file.pyc	552	39519cf7cf18c04fc7b8b8010490f7dd
 library/encodings/cp865.pyc	7868	7d40a7ba053ac23339218be8799e5397
 library/lib/gtk-2.0/2.10.0/engines/libwimp.dll	97984	a5bbbe46e1363aba9020a76f2d58e9d6
@@ -145,5 +145,5 @@
 library/share/locale/hu/LC_MESSAGES/gtk20-properties.mo	167125	cd1b1b3693c1e3c74bfcea20be640cc6
 conn_red.png	914	860388cb7c3b26b2f348fdbee40780ce
-library/bz2.pyc	534	5595f0a4a8ffd0b63f7542fddc918028
+library/bz2.pyc	534	4a83ab9de101cd0ce5b9b866f5661e85
 library/xml/sax/expatreader.pyc	13563	4f64c0efb2f1f8dbba84cdb5c6036f2d
 library/email/utils.pyc	8840	a7be428df6fddee6121cfce55382d1f8
@@ -161,6 +161,6 @@
 library/mlx/gui/statusbar.pyc	4812	87773f7d0bd28ed6250acf1972110ca8
 library/warnings.pyc	12666	9788b5f45765e8204e04c820f2711094
-mlxupdate.exe	18944	b8bf9f3d22348aa1f78727f81d967f93
-library/mlx/const.pyc	6710	2187949c18be095bada1927f3127d0cf
+mlxupdate.exe	19456	e9a978949f7755311ad9e0db55f1e63c
+library/mlx/const.pyc	6707	9375ae285d18c54e13107e5775868192
 library/email/errors.pyc	3229	cdb78ab237e195ad69f059128bc03b1d
 library/linecache.pyc	3091	666e6f81b0ea9a7637f8068493f738d5
@@ -175,5 +175,5 @@
 library/shlex.pyc	7282	cbe1a4823894c97c87d01f9d9faf5b8f
 library/cairo/__init__.pyc	142	010dd7cc8485565d5782d60e92e4ba34
-library/_ssl.pyc	537	d7b3b5f87a333acdf28a28f52c5c8ce7
+library/_ssl.pyc	537	2cb40e7a5123a20f42dca69bbda9b17c
 library/encodings/iso8859_8.pyc	2717	f3ad6ce58cfac9e3ca86cf5c2fef092b
 library/encodings/iso2022_jp_1.pyc	1699	faed9d5747e982cec9fa8b3ad8e1de26
@@ -196,6 +196,6 @@
 library/encodings/cp1252.pyc	2676	b4c43cc72650c911cf3654dbaf565df9
 library/share/locale/hu/LC_MESSAGES/atk10.mo	8465	e3f3466da367215aad971d7b0394229d
-library/unicodedata.pyc	558	9570da5a79cb8e2156f6577185461f85
-library/select.pyc	543	ad5bc4844763975968138f81e1e9ac65
+library/unicodedata.pyc	558	b3e806269dfb39ac4ab81ba5049f2458
+library/select.pyc	543	0608a6239838009159f223f473ae2a6a
 library/encodings/uu_codec.pyc	4646	5282a5fcb676851224d2924aa3e48a9e
 library/ConfigParser.pyc	23857	1d17020dd0000ce0f73de812effa152f
@@ -217,5 +217,4 @@
 library/mlx/singleton.pyc	9184	3b71000d428959ab355db2658cea9557
 library/locale.pyc	48754	a51d20267132acc6bc66ac6252cf870f
-library/xplra.pyc	32012	50a1d9f19c0cc88783d264909ad1c678
 library/socket.pyc	15488	35f8eb455d6d8df8e19826d1dd7193f2
 sounds/notify.wav	119384	108025b17f67e61946df5d7fbf713cdb
@@ -229,5 +228,5 @@
 doc/manual/hu/flightInfoTab.png	28786	3e8af27775131f02696b0912ca441f36
 library/encodings/utf_8_sig.pyc	4625	1b1405db186e5819fa271ff96c1ca2c5
-library/pangocairo.pyc	555	33065d79493949ba073d7fc7b165004b
+library/pangocairo.pyc	555	5ef32a4f4e2c28fa162011c342e3b789
 library/encodings/cp1255.pyc	2697	b265913c887f2e1c8736632b652c0093
 library/encodings/zlib_codec.pyc	4308	319c9073aff840436a03cc1fa0b08fb5
@@ -236,5 +235,5 @@
 doc/manual/hu/connect.png	28822	929f3eb85ee3cad019e12017c923f664
 library/encodings/palmos.pyc	2876	9284ad53dcfd82dfae0a79923b1cf91d
-library/mlx/web.pyc	30343	0cab98a640fd3937828d24c2fe8ef0ef
+library/mlx/web.pyc	30343	d2e330da2cffcb9f4abc5f3b9941b2cb
 library/mlx/gui/gates.pyc	5384	9f6acad03872832505e31406a1b6762b
 library/email/feedparser.pyc	10682	4de6a63da8dc270c9881edb9c2f28508
@@ -242,5 +241,5 @@
 library/intl.dll	152489	eb2d4c4d4a527bc88a69a16cc99afcf5
 library/encodings/mbcs.pyc	1883	2213911a7dd0deada6799b63e18b695b
-library/pyuipc.pyc	543	c194030ac361f97edfcf756a91a949f1
+library/pyuipc.pyc	543	bb664c97a351eb86af6fc2889e2cf07a
 sounds/TOC.mp3	273032	fae1be2ad25c8b54806bd1d759919705
 library/encodings/iso8859_4.pyc	2678	16f2fe7994051752360c533c052b892b
@@ -266,11 +265,11 @@
 doc/manual/hu/flightSelection.png	30815	e8bcdda6079c6b16ffa72ca62c21ca85
 library/win32pipe.pyd	24064	de374eded459293b2a7eb8ed8fb38eaa
-library/win32pipe.pyc	552	79ce5d61fe62ec37a212e8a854f2807b
+library/win32pipe.pyc	552	3525d9ce759fb173fb5949768955a43c
 doc/manual/hu/cruise.png	27460	a2610173563e45baae1b0f9e63007ebd
 doc/manual/hu/logTab.png	28706	f48004202310bd2a1cb2f873d8064e93
 library/encodings/iso2022_jp_2004.pyc	1723	66376e788f3819e781897268c1100986
-library/win32event.pyc	555	63b964537d2e2157645cab4a6b90e68d
+library/win32event.pyc	555	062a638079612d30bbf679ada15dd79b
 library/encodings/cp866.pyc	8103	f36418dcf93b17b3ced63bd544f44159
-library/gio/_gio.pyc	549	41b7fad0fabe6f41db16a6e05d415848
+library/gio/_gio.pyc	549	332e8e3dcee26679a37beb64db0bc90b
 library/encodings/cp437.pyc	7874	63f1278c0a66129c6fb4f504d6b61b66
 doc/manual/hu/helpTab.png	27961	8e7cc4aeb8d7f40fcf186c7caf53583b
@@ -295,5 +294,5 @@
 library/mlx/gui/pirep.pyc	16749	7a295b28dbdad43b33c52d814be60792
 library/mimetypes.pyc	17806	927ce6a7079707aaee925e855ed23454
-library/_ctypes.pyc	546	d4c47f95473dc9d7b363d62b26db0a7e
+library/_ctypes.pyc	546	e0cd0d88a4af0cd4307b0da1351b7c55
 sounds/F70taxi.mp3	154854	51332dc691d3519355f61ed06c959d8d
 library/encodings/cp857.pyc	7611	1b46c8959ac097b73e1c680d464cdc32
@@ -313,5 +312,5 @@
 library/repr.pyc	5045	82f0d89c685c3dacd941e01e4b2f31ef
 library/quopri.pyc	6352	87c42d94f753dd4c8a761cfa79453bb8
-library/mlx/gui/monitor.pyc	12214	6814c319b26ad7213e0759cf909c788d
+library/mlx/gui/monitor.pyc	12021	71dd3fb4b634cb6ac20ee889ca3a09c0
 library/encodings/latin_1.pyc	2111	52427573ccbfd06220b67d5a9dd1376e
 library/mlx/update.pyc	16952	b4c0e85d094410aa0b7075476962730d
@@ -322,5 +321,5 @@
 doc/manual/en/gatesTab.png	29585	00ebc96a2b4a7473dbb6a3162a04192f
 library/bdb.pyc	17708	9a8fdcaa65f595c842689247847879d9
-library/mlx/gui/flight.pyc	112899	536e12fba696bbc0781e2b5e73e8ea54
+library/mlx/gui/flight.pyc	111770	6991ddb672d43b8de56d6e8c30694ae7
 library/unittest/case.pyc	37758	1d2235e74c246b562c5c00ddf73c621a
 library/subprocess.pyc	38648	c9f749db06dfc9fb32079de51d6efd01
@@ -338,5 +337,5 @@
 library/encodings/cp863.pyc	7868	fc7ff06dab536b93c68fcb8e7bac713f
 library/xml/parsers/__init__.pyc	294	83f6a77ed8cd962b3c75c4779dc557ac
-library/pyexpat.pyc	546	3868a2225d9e99907f2cd9d97ef9a300
+library/pyexpat.pyc	546	90f96a71a10eb1e06fe279e95e0dc139
 doc/manual/hu/gateSelection.png	29237	bac37e7001261a40a84e4202247f6052
 logo.png	69816	4a7517b22cfd75cc9c15e3fc1b7ebeec
@@ -364,19 +363,18 @@
 library/_socket.pyd	38400	5d273be76603399e88cf57f2605004bf
 sounds/ding.wav	80856	18e639792d3767436ac6955eb60e4f54
-library/_socket.pyc	546	e4eede84eacb1ffb8a725cfda432fb76
+library/_socket.pyc	546	4f16cf07fdd8412d1ea8228238b1556c
 library/encodings/hex_codec.pyc	3520	a8b8d5b7c8810379c7007bcbc253951c
-library/mlx/checks.pyc	58567	d6c6eebab7a0a19c5f33007ce8b4c3e5
+library/mlx/checks.pyc	58364	c7c535545956d5f434e36c67d398db5f
 doc/manual/en/statusIcon2.png	5875	71fc121823dee0a4c00715fac1b5665c
-library/mlx/sound.pyc	10001	78655c3a51de983d8e550934c05e1f30
+library/mlx/sound.pyc	6326	19c542e4f40270f46e42ac087a3532b3
 doc/manual/en/pirepViewer.png	25098	7c545e70b995ac0f9fcae93fe5d0e899
 library/encodings/aliases.pyc	8750	75c22196420d0157fec085d285947a71
-library/glib/_glib.pyc	555	465b8ddc57386c9f7ef448d9cb802abd
+library/glib/_glib.pyc	555	d24c8e5801a398eab8516b8707049127
 library/libpangowin32-1.0-0.dll	108945	d07f128828225b7cc38e9e590eb3ba8a
 library/encodings/iso8859_10.pyc	2693	5e6cc8f721486ddbc1c99da285e13191
-library/win32api.pyc	549	efb111e7d3dae80fd15bf47d026e6114
+library/win32api.pyc	549	a5622f32da0646859ff8379bcc24a3b4
 library/gobject/constants.pyc	1957	2e9cdc605e7c449ef4fc23f56128acec
 library/libgtk-win32-2.0-0.dll	4938115	cc6dca192aca6f91bd96a5b5f86e036d
 doc/manual/hu/calloutsEditor.png	16026	fede870894a85e5d21ca16a026aa6a98
-library/mlx/xplane.pyc	66878	9ee20e3efd68fd414ca3b4716c1f2985
 library/ssl.pyc	13785	d90c880699ecbedb3182f556b9733868
 library/tempfile.pyc	18526	e2cc2d63c29e15f20ee9325e790643a3
@@ -421,6 +419,6 @@
 library/libgthread-2.0-0.dll	44287	7ad6f303082b382bff7bafbab246c61f
 library/glib._glib.pyd	58368	0de636503e43c4eb00e80927bc9bda97
-library/mlx/config.pyc	30521	406992cc40c69fc2054e02d516088ba9
-library/atk.pyc	534	7e987d4ee2de16ac0050d9e1944a860a
+library/mlx/config.pyc	29918	fca1bd8ff8948570ce4ff0a673cd99e3
+library/atk.pyc	534	58aa8ee24d8a61d0e2b15eb6b9200897
 library/gio._gio.pyd	263168	acb8c95fdc391079bebdf7d8685b0dbc
 library/encodings/cp861.pyc	7868	c97a8970ce4d9f40cbafbea6576fbdca
@@ -432,7 +430,7 @@
 library/__future__.pyc	4177	43d264d951ac2085334c7b9dd4558595
 library/logging/__init__.pyc	54813	7bcdf2e8da474f5e94d8e499f6fc3ed4
-runmlx.exe	63488	3060aa0ed73648edc26992e224568352
+runmlx.exe	64000	7e0ddfc5d67212ce2da74aa6b1b5b08e
 library/optparse.pyc	51253	39594a40bc1222173d57b7d5740e3d92
-library/mlx/fs.pyc	11803	268cda55420c4ce0750029ea203155e6
+library/mlx/fs.pyc	11756	a758a6bd0c7cc28dbc9e3c0a33fe18d1
 doc/manual/en/takeoff.png	26128	63fb0227347eba88fe4f108d730dc8c0
 library/unittest/result.pyc	7444	aefbb3cc79c0ff17787ce84faed7f5e8
@@ -445,5 +443,5 @@
 library/glib/option.pyc	11891	bd90183c75d8f473ecf653e3d63a27f9
 library/StringIO.pyc	11100	f4eb4a2bb3d6fb0af925681c5375c673
-library/pango.pyc	540	1b3d8d42905b120b95525147e2fd4b0a
+library/pango.pyc	540	52e336c3a5a39745e9a075b943482f9c
 Microsoft.VC90.CRT/msvcp90.dll	568832	6de5c66e434a9c1729575763d891c6c2
 library/sre_parse.pyc	18380	fe2376a101668be1124f9ee316662bab